#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include <usbdrv.h>
#define delays 1

int List[6];//Keep Position Data
int stage;
int i;
int speed;

void ResetList()
{
	for (i =0;i<6;i++)//initial new list data
            List[i] = 0;
}

void PortB(int data)// return position data in List
{
	switch(data)
	{
        	case 0:PORTB = 0b00000000; break;
		case 1:PORTB = 0b00100000; break;
		case 2:PORTB = 0b00010000; break;
		case 3:PORTB = 0b00001000; break;
		case 4:PORTB = 0b00000100; break;
		case 5:PORTB = 0b00000010; break;
		case 6:PORTB = 0b00000001; break;
		case 7:PORTB = 0b11111111; break;
	}
}

void ShowLED()//PORTC = 0 PORTB = 1
{
	PORTD = 0b01000000;//Disable Player Position

	_delay_ms(delays);//First Line
	PORTC = 0b00011111;
	PortB(List[0]);

	_delay_ms(delays);
	PORTC = 0b00101111;
	PortB(List[1]);

	_delay_ms(delays);
	PORTC = 0b00110111;	
	PortB(List[2]);

	_delay_ms(delays);
	PORTC = 0b00111011;
	PortB(List[3]);

	_delay_ms(delays);
	PORTC = 0b00111101;
	PortB(List[4]);
}

void change()//change object position
{
     int i;
     for (i =4 ;i>=1;i--)
         List[i] = List[i-1];
}

void random() //random new object position
{
     List[0] = (rand()%7);
}

uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000; // เลือกใช้แรงดันอ้างอิงจากขา AREF
    ADMUX |= channel;   // ตั้ง MUX ให้ชี้ไปยัง channel
    ADCSRA = 0b11000110;
    //         ||   -+-
    //         ||    |
    //         ||    +-> ปรับคล็อกของ ADC ให้เป็น 1/64 ของคล็อกระบบ
    //         |+->เริ่มแปลงค่าแอนะล็อกเป็นดิจิทัล (บิต ADSC)
    //         |
    //         +-> Enable ADC (บิต ADEN)

    while ((ADCSRA & (1<<ADSC))) // รอจนบิต ADSC (บิต 6) กลายเป็น 0
        ;
    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}

void Check()//Check End Game
{
	if (List[5] == List[4])
	{
	    stage = 1;
	    i = 0;
	}
}

int Player(uint16_t x) //Search Player Position
{
	if(x > 1000)
	    List[5] = 1;
	else if (x > 985)
	    List[5] = 2;
	else if (x > 970)
	    List[5] = 3;
	else if (x > 940)
	    List[5] = 4;
	else if (x > 800)
	    List[5] = 5;
	else if (x > 0)
	    List[5] = 6;
	else
	    List[5] = 7;
	return 0;
}

void Showall()
{
	PORTD = 0b00000000;
	PORTC = 0b00000000;
	PORTB = 0b00111111;
}

void CloseLight()
{
	PORTD = 0b11111111;
	PORTC = 0b11111111;
	PORTB = 0b00000000;
}

void ShowPlayer()//Show Player Position
{
	_delay_ms(delays);
	PORTC = 0b00111111;//Disable Object Position
	
	PORTD = 0b00000000;
	PortB(List[5]);
	_delay_ms(delays);
}

void Reset()
{
	stage = 0;
	speed = 100;
	i = 0;
	ResetList();
}

int main()
{
    DDRB = 0b00111111;
    DDRC = 0b00111111;
    DDRD = 0b01111111;
//    PORTD = 0b01000000;

    uint16_t posi;
    speed = 100;
    i = 0;
    stage = 0;
    ResetList();
    while (1)
    {
	i++;
	if (!stage)
	{
	    if (i%speed==0){
	      Check();
              change();
              random();
	    }
	    if (i%50==0)
	    {
	      speed--;
	    }
            ShowLED();
	    Player(read_adc(0));
	    ShowPlayer();
	}
	else
	{
	    Showall();
	    _delay_ms(1000);
	    CloseLight();
	    _delay_ms(1000);
	    if(i>3)
		if(posi != read_adc(0))
		{
		    Reset();
		}
	    posi = read_adc(0);
	}
    }
    return 0;
}
